; ++++ Tree View Example +++++
; + Programmed by Luis Costa ++
; ++++++ Lisbon, Portugal +++++
; +++ xandaz@hotmail.com ++++

.586
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
FillTree        PROTO	:DWORD,:DWORD
AddString       PROTO   :DWORD,:DWORD
AddAsterisk      PROTO   :DWORD
DeleteLast      PROTO   :DWORD,:DWORD
CopyString      PROTO   :DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
include \masm32\include\shell32.inc
include \masm32\include\ole32.inc
include \masm32\include\colib.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\colib.lib

.const

MainWindowWidth         equ             400
MainWindowHeight        equ             300

.data


hInstance       DWORD           ?
CommandLine     LPSTR           ?

hMainWindow     dd              ?
MainWindowClass db              'MainWindowClass',0
MainWindowName  db              'Tree View Example',0

; +++ Tree View related +++

TreeViewClass   db      'SysTreeView32',0
hTreeView          dd                   ?
tvis            TV_INSERTSTRUCT         <>
tvi                     TV_ITEM                 <>

; ++++ Static related +++++

StaticClass     db              'STATIC',0
hStatic           dd                    ?

; +++ File Operations and Others related ++++

hFind                   dd                  ?
w32fd           WIN32_FIND_DATA         <>
w32fd2          WIN32_FIND_DATA         <>
FileBuffer             db     252             dup(0)
StartingDrive        db      'c:',0
Asterisk               db      '\*',0
rect                         RECT                  <>
shfi                    SHFILEINFO               <>
InitSysIcon           dd              FALSE
DirectoryBuffer      db      128 dup(0)
BlankString           db      128 dup(' ')

.code
        start:
                invoke  GetModuleHandle,NULL
                mov     hInstance,eax
                invoke  GetCommandLine
                mov     CommandLine,eax
                invoke  InitCommonControls
                invoke  CoInitialize,NULL
                invoke  WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
                invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

        local   wc:WNDCLASSEX
        local   msg:MSG

        mov     wc.cbSize,sizeof wc
        mov     wc.style,CS_HREDRAW+CS_VREDRAW
        mov     wc.lpfnWndProc,offset WndProc
        mov     wc.lpszMenuName,NULL
        mov     wc.lpszClassName,offset MainWindowClass
        mov     wc.cbClsExtra,NULL
        mov     wc.cbWndExtra,NULL
        mov     wc.hbrBackground,COLOR_WINDOW
        push    hInst
        pop     wc.hInstance
        invoke  LoadIcon,NULL,IDI_APPLICATION
        mov     wc.hIcon,eax
        mov     wc.hIconSm,eax
        invoke  LoadCursor,NULL,IDC_ARROW
        mov     wc.hCursor,eax
        invoke  RegisterClassEx,addr wc
        invoke  GetSystemMetrics,SM_CYSCREEN
        shr     eax,1
        sub     eax,MainWindowHeight/2
        push    eax
        invoke  GetSystemMetrics,SM_CXSCREEN
        shr     eax,1
        sub     eax,MainWindowWidth/2
        pop     ebx
        invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\
                eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
        mov     hMainWindow,eax
        invoke  ShowWindow,eax,SW_SHOWNORMAL
        invoke  UpdateWindow,hMainWindow
        
        .while  TRUE

                invoke  GetMessage,addr msg,NULL,0,0

        .break .if (!eax)

                invoke  TranslateMessage,addr msg
                invoke  DispatchMessage,addr msg

        .endw

        mov     eax,msg.wParam
        ret

WinMain endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

        local   cnt:DWORD
        
        .if     uMsg==WM_DESTROY

                invoke  PostQuitMessage,NULL
                
        .elseif uMsg==WM_CREATE

                mov     edi,lParam
                .if     [edi.CREATESTRUCT].hWndParent==NULL
                        invoke  GetClientRect,hWnd,addr rect
                        sub     rect.bottom,30
                        invoke  CreateWindowEx,WS_EX_STATICEDGE,addr TreeViewClass,NULL,WS_VISIBLE+WS_CHILD+\
                                        TVS_HASBUTTONS+TVS_HASLINES+TVS_LINESATROOT,0,0,rect.right,rect.bottom,\
                                        hWnd,NULL,hInstance,NULL
                        mov     hTreeView,eax
                        mov     eax,rect.bottom
                        add     eax,2
                        mov     rect.top,eax
                        mov     rect.bottom,28
                        invoke  CreateWindowEx,WS_EX_STATICEDGE,addr StaticClass,NULL,WS_VISIBLE+WS_CHILD+SS_SIMPLE,\
                                        0,rect.top,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
                        mov     hStatic,eax      
                        invoke  SendMessage,hTreeView,WM_GETFONT,NULL,NULL
                        invoke  SendMessage,hStatic,WM_SETFONT,eax,FALSE                                  
                        invoke  CopyString,addr FileBuffer,addr StartingDrive
                        invoke  AddAsterisk,addr FileBuffer
                        invoke  FillTree,hWnd,NULL
                .endif 
                
        .elseif uMsg==WM_NOTIFY
                mov     edi,lParam
                .if     [edi.NM_TREEVIEW].hdr.code==TVN_SELCHANGED
                        mov     eax,[edi.NM_TREEVIEW].itemNew.hItem
                        push    eax
                        call    ClearBuffer
                        mov     cnt,0
tvn_loop_0:
                        push    eax
                        invoke  SendMessage,hTreeView,TVM_GETNEXTITEM,TVGN_PARENT,eax
                        inc     cnt
                        cmp     eax,NULL
                        jne     tvn_loop_0
                        mov     ecx,cnt
                        mov     tvi.imask,TVIF_HANDLE+TVIF_TEXT
                        mov     tvi.pszText,offset DirectoryBuffer
                        mov     tvi.cchTextMax,256
                        invoke  CopyString,addr FileBuffer,addr StartingDrive

tvn_loop_1:
                        pop     tvi.hItem
                        push    ecx
                        invoke  SendMessage,hTreeView,TVM_GETITEM,NULL,addr tvi
                        invoke  AddAsterisk,addr FileBuffer
                        invoke  AddString,addr FileBuffer,tvi.pszText
                        pop     ecx
                        dec     ecx
                        jcxz     ender
                        jmp     tvn_loop_1
ender:                        
                        invoke  AddAsterisk,addr FileBuffer
                        invoke  SendMessage,hStatic,WM_SETTEXT,NULL,addr BlankString
                        invoke  SendMessage,hStatic,WM_SETTEXT,NULL,addr FileBuffer
                        pop     eax
                        push    eax
                        invoke  FillTree,hWnd,eax
                        pop     eax
                        invoke  SendMessage,hTreeView,TVM_EXPAND,TVE_EXPAND,eax
                                        
                 .endif       
                                                                                                        
        .else

                invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
                ret

        .endif

        xor     eax,eax
        ret

WndProc endp

FillTree        PROC    hWnd:DWORD,hParent:DWORD

        push    hParent
        pop     tvis.hParent
        mov     tvis.hInsertAfter,TVI_LAST
        mov     tvis.item.imask,TVIF_TEXT+TVIF_IMAGE+TVIF_SELECTEDIMAGE+TVIF_CHILDREN
        
        invoke  FindFirstFile,addr FileBuffer,addr w32fd
        cmp     eax,NULL
        je      nomore_files
        mov     hFind,eax
compare:
        cmp     w32fd.cFileName,'.'
        je       next_file
        test     w32fd.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY
        jnz     insert_item
next_file:      
        invoke  FindNextFile,hFind,addr w32fd
        cmp     eax,NULL
        je      nomore_files
        jmp     compare

insert_item:
        cmp     InitSysIcon,FALSE
        jne     skippers
        invoke  AddString,addr FileBuffer,addr w32fd.cFileName
        invoke  SHGetFileInfo,addr FileBuffer,NULL,addr shfi,sizeof shfi,SHGFI_SMALLICON+SHGFI_SYSICONINDEX
        invoke  SendMessage,hTreeView,TVM_SETIMAGELIST,TVSIL_NORMAL,eax
        push    shfi.iIcon
        pop     tvis.item.iImage
        invoke  SHGetFileInfo,addr FileBuffer,NULL,addr shfi,sizeof shfi,SHGFI_OPENICON+SHGFI_SYSICONINDEX
        push    shfi.iIcon
        pop     tvis.item.iSelectedImage
        mov     InitSysIcon,TRUE
        invoke  DeleteLast,addr FileBuffer,1
skippers:        
        push    offset w32fd.cFileName
        pop     tvis.item.pszText
        invoke  AddString,addr FileBuffer,addr w32fd.cFileName
        invoke  AddAsterisk,addr FileBuffer
        push    hFind
        call     CheckForSubFolder
        invoke  DeleteLast,addr FileBuffer,2
        pop     hFind
no_subfolder:        
        invoke  SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
        jmp     next_file
nomore_files:
        invoke  CloseHandle,hFind
        ret

FillTree        endp        

AddString       PROC    MainString:DWORD,StringAdd:DWORD

        mov     esi,MainString
        cld
loop_0:
        lodsb   
        cmp     al,0
        jne     loop_0
        dec     esi
        std
loop_1:
        lodsb   
        
        cmp     al,'\'
        jne     loop_1
        add     esi,2
        mov     edi,esi
        mov     esi,StringAdd
        cld
loop_2:
        lodsb   
        cmp     al,0
        je      ender
        stosb
        jmp     loop_2
ender:
        stosb
        ret

AddString       endp

AddAsterisk      PROC    MainString:DWORD

        mov     esi,MainString    
        cld
loop_0:
        lodsb
        cmp     al,0
        jne     loop_0
        dec     esi
        mov     edi,esi
        mov     ax,'*\'
        stosw
        mov     al,0
        stosb
        ret
        
AddAsterisk      endp        

DeleteLast      PROC    MainString:DWORD,dwLoops:DWORD

        mov     esi,MainString
        cld
loop_0:
        lodsb   
        cmp     al,0
        jne     loop_0
        dec     esi
        std
        mov     ecx,dwLoops
loop_1:
        lodsb   
        cmp     al,'\'
        jne     loop_1
        dec     ecx
        jcxz    next_step   
        jmp     loop_1
next_step:        
        add     esi,2
        mov     edi,esi
        cld
        xor     al,al
        stosb                
        ret

DeleteLast      endp

CheckForSubFolder       PROC

        invoke  FindFirstFile,addr FileBuffer,addr w32fd2
        cmp     eax,INVALID_HANDLE_VALUE
        je      nomore_files
        mov     hFind,eax
        mov     edi,offset w32fd2.cFileName
compare:
        cmp     w32fd2.cFileName,'.'                                
        je      next_file
        test    w32fd2.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY
        jz      next_file
        invoke  CloseHandle,hFind
        mov     tvis.item.cChildren,1
        ret
next_file:      
        invoke  FindNextFile,hFind,addr w32fd2
        cmp     eax,NULL
        je      nomore_files
        jmp     compare
nomore_files:
        invoke  CloseHandle,hFind
        mov     tvis.item.cChildren,NULL
        ret

CheckForSubFolder       endp

ClearBuffer     PROC

        push    eax
        push    ecx
        pushfd                
        mov     ecx,256
        shr     ecx,4
        xor     eax,eax
        cld
loop_0:
        stosd
        dec     ecx
        jcxz    ender
        jmp     loop_0
ender:
        popfd
        pop     ecx
        pop     eax
        ret

ClearBuffer     endp           

CopyString      PROC    MainString:DWORD,StringCopy:DWORD

        mov     esi,StringCopy
        mov     edi,MainString
        cld
loop_0:
        lodsb
        cmp     al,0
        je      ender
        stosb
        jmp     loop_0
ender:
        stosb
        ret

CopyString      endp                                     
end     start                                       
